## newsboat 2.10.2

=== Makefile ===
# important directories
prefix?=/usr/local
mandir?=$(prefix)/share/man
datadir?=$(prefix)/share
localedir?=$(datadir)/locale
docdir?=$(datadir)/doc/$(PACKAGE)

CPPCHECK_JOBS?=5

# compiler
CXX?=c++

# compiler and linker flags
DEFINES=-DLOCALEDIR=\"$(localedir)\"

ifneq ($(wildcard .git/.),)
GIT_HASH:=$(shell git describe --abbrev=4 --dirty --always --tags)
DEFINES+=-DGIT_HASH=\"$(GIT_HASH)\"
endif

WARNFLAGS=-Werror -Wall -Wextra -Wunreachable-code
INCLUDES=-Iinclude -Istfl -Ifilter -I. -Irss
BARE_CXXFLAGS=-std=c++11 -ggdb $(INCLUDES)
CXXFLAGS+=$(BARE_CXXFLAGS) $(WARNFLAGS) $(DEFINES)
LDFLAGS+=-L.

PACKAGE=newsboat

ifeq (, $(filter $(MAKECMDGOALS),distclean run-i18nspector))
include config.mk
endif

ifeq ($(PROFILE),1)
CXXFLAGS+=-fprofile-arcs -ftest-coverage
LDFLAGS+=-fprofile-arcs -ftest-coverage
endif

LIB_SOURCES:=$(shell cat mk/libboat.deps)
LIB_OBJS:=$(patsubst %.cpp,%.o,$(LIB_SOURCES))
LIB_OUTPUT=libboat.a

FILTERLIB_SOURCES=filter/Scanner.cpp filter/Parser.cpp filter/FilterParser.cpp
FILTERLIB_OBJS:=$(patsubst %.cpp,%.o,$(FILTERLIB_SOURCES))
FILTERLIB_OUTPUT=libfilter.a

NEWSBOAT=newsboat
NEWSBOAT_SOURCES:=$(shell cat mk/newsboat.deps)
NEWSBOAT_OBJS:=$(patsubst %.cpp,%.o,$(NEWSBOAT_SOURCES))
NEWSBOAT_LIBS=-lboat -lfilter -lpthread -lrsspp

RSSPPLIB_SOURCES=$(sort $(wildcard rss/*.cpp))
RSSPPLIB_OBJS=$(patsubst rss/%.cpp,rss/%.o,$(RSSPPLIB_SOURCES))
RSSPPLIB_OUTPUT=librsspp.a


PODBOAT=podboat
PODBOAT_SOURCES:=$(shell cat mk/podboat.deps)
PODBOAT_OBJS:=$(patsubst %.cpp,%.o,$(PODBOAT_SOURCES))
PODBOAT_LIBS=-lboat -lpthread

ifeq (, $(filter Linux GNU GNU/%, $(shell uname -s)))
NEWSBOAT_LIBS+=-liconv -lintl
PODBOAT_LIBS+=-liconv -lintl
endif

# additional commands
MKDIR=mkdir -p
INSTALL=install
A2X=a2x
MSGFMT=msgfmt
RANLIB?=ranlib
AR?=ar
CHMOD=chmod

STFLHDRS:=$(patsubst %.stfl,%.h,$(wildcard stfl/*.stfl))
POFILES:=$(wildcard po/*.po)
MOFILES:=$(patsubst %.po,%.mo,$(POFILES))
POTFILE=po/newsboat.pot

TEXTCONV=./txt2h
RM=rm -f

all: doc $(NEWSBOAT) $(PODBOAT) mo-files

NB_DEPS=$(LIB_OUTPUT) $(FILTERLIB_OUTPUT) $(NEWSBOAT_OBJS) $(RSSPPLIB_OUTPUT)

$(NEWSBOAT): $(NB_DEPS)
	$(CXX) $(CXXFLAGS) -o $(NEWSBOAT) $(NEWSBOAT_OBJS) $(NEWSBOAT_LIBS) $(LDFLAGS)

$(PODBOAT): $(LIB_OUTPUT) $(PODBOAT_OBJS)
	$(CXX) $(CXXFLAGS) -o $(PODBOAT) $(PODBOAT_OBJS) $(PODBOAT_LIBS) $(LDFLAGS)

$(LIB_OUTPUT): $(LIB_OBJS)
	$(RM) $@
	$(AR) qc $@ $^
	$(RANLIB) $@

$(RSSPPLIB_OUTPUT): $(RSSPPLIB_OBJS)
	$(RM) $@
	$(AR) qc $@ $^
	$(RANLIB) $@

$(FILTERLIB_OUTPUT): $(FILTERLIB_OBJS)
	$(RM) $@
	$(AR) qc $@ $^
	$(RANLIB) $@

regenerate-parser:
	$(RM) filter/Scanner.cpp filter/Parser.cpp filter/Scanner.h filter/Parser.h
	cococpp -frames filter filter/filter.atg

%.o: %.cpp
	$(CXX) $(CXXFLAGS) -o $@ -c $<

%.h: %.stfl
	$(TEXTCONV) $< .stfl > $@

clean-newsboat:
	$(RM) $(NEWSBOAT) $(NEWSBOAT_OBJS)

clean-podboat:
	$(RM) $(PODBOAT) $(PODBOAT_OBJS)

clean-libboat:
	$(RM) $(LIB_OUTPUT) $(LIB_OBJS)

clean-librsspp:
	$(RM) $(RSSPPLIB_OUTPUT) $(RSSPPLIB_OBJS)

clean-libfilter:
	$(RM) $(FILTERLIB_OUTPUT) $(FILTERLIB_OBJS)

clean-doc:
	$(RM) -r doc/xhtml 
	$(RM) doc/*.xml doc/*.1 doc/newsboat-cfgcmds.txt doc/podboat-cfgcmds.txt \
		doc/newsboat-keycmds.txt doc/configcommands-linked.dsv \
		doc/podboat-cmds-linked.dsv doc/keycmds-linked.dsv \
		doc/gen-example-config doc/generate doc/generate2

clean: clean-newsboat clean-podboat clean-libboat clean-libfilter clean-doc clean-librsspp
	$(RM) $(STFLHDRS) xlicense.h

distclean: clean clean-mo test-clean profclean
	$(RM) core *.core core.* config.mk

doc: doc/newsboat.1 doc/podboat.1 doc/xhtml/newsboat.html doc/xhtml/faq.html

doc/xhtml/newsboat.html: doc/newsboat.txt doc/chapter-firststeps.txt doc/configcommands-linked.dsv \
		doc/keycmds-linked.dsv doc/chapter-tagging.txt doc/chapter-snownews.txt \
		doc/chapter-cmdline.txt doc/chapter-podcasts.txt doc/podboat-cmds-linked.dsv \
		doc/chapter-password.txt
	$(MKDIR) doc/xhtml
	$(A2X) -f xhtml -D doc/xhtml doc/newsboat.txt
	$(CHMOD) u+w doc/xhtml/docbook-xsl.css
	echo "/* AsciiDoc's new tables have <p> inside <td> which wastes vertical space, so fix it */" >> doc/xhtml/docbook-xsl.css
	echo "td > p { margin: 0; }" >> doc/xhtml/docbook-xsl.css
	echo "td > p + p { margin-top: 0.5em; }" >> doc/xhtml/docbook-xsl.css
	echo "td > pre { margin: 0; white-space: pre-wrap; }" >> doc/xhtml/docbook-xsl.css

doc/xhtml/faq.html: doc/faq.txt
	$(MKDIR) doc/xhtml
	$(A2X) -f xhtml -D doc/xhtml doc/faq.txt
	$(CHMOD) u+w doc/xhtml/docbook-xsl.css
	echo "/* AsciiDoc's new tables have <p> inside <td> which wastes vertical space, so fix it */" >> doc/xhtml/docbook-xsl.css
	echo "td > p { margin: 0; }" >> doc/xhtml/docbook-xsl.css
	echo "td > p + p { margin-top: 0.5em; }" >> doc/xhtml/docbook-xsl.css
	echo "td > pre { margin: 0; white-space: pre-wrap; }" >> doc/xhtml/docbook-xsl.css

doc/generate: doc/generate.cpp doc/split.h
	$(CXX) $(CXXFLAGS) -o doc/generate doc/generate.cpp

doc/newsboat-cfgcmds.txt: doc/generate doc/configcommands.dsv
	doc/generate doc/configcommands.dsv > doc/newsboat-cfgcmds.txt

doc/generate2: doc/generate2.cpp
	$(CXX) $(CXXFLAGS) -o doc/generate2 doc/generate2.cpp

doc/newsboat-keycmds.txt: doc/generate2 doc/keycmds.dsv
	doc/generate2 doc/keycmds.dsv > doc/newsboat-keycmds.txt

doc/newsboat.1: doc/manpage-newsboat.txt doc/chapter-firststeps.txt doc/newsboat-cfgcmds.txt \
		doc/newsboat-keycmds.txt doc/chapter-tagging.txt doc/chapter-snownews.txt \
		doc/chapter-cmdline.txt
	$(A2X) -f manpage doc/manpage-newsboat.txt

doc/podboat-cfgcmds.txt: doc/generate doc/podboat-cmds.dsv
	doc/generate doc/podboat-cmds.dsv 'pb-' > doc/podboat-cfgcmds.txt

doc/podboat.1: doc/manpage-podboat.txt doc/chapter-podcasts.txt doc/podboat-cfgcmds.txt
	$(A2X) -f manpage doc/manpage-podboat.txt

doc/gen-example-config: doc/gen-example-config.cpp doc/split.h
	$(CXX) $(CXXFLAGS) -o doc/gen-example-config doc/gen-example-config.cpp

doc/example-config: doc/gen-example-config doc/configcommands.dsv
	cat doc/configcommands.dsv | doc/gen-example-config > doc/example-config

# add hyperlinks for every configuration command
doc/configcommands-linked.dsv: doc/configcommands.dsv
	sed -E 's/^([^|]+)/[[\1]]<<\1,`\1`>>/' doc/configcommands.dsv > doc/configcommands-linked.dsv

# add hyperlinks for every configuration command
doc/podboat-cmds-linked.dsv: doc/podboat-cmds.dsv
	sed -E 's/^([^|]+)/[[\1]]<<\1,`\1`>>/' doc/podboat-cmds.dsv > doc/podboat-cmds-linked.dsv

doc/keycmds-linked.dsv: doc/keycmds.dsv
	sed -E 's/^([^|]+)/[[\1]]<<\1,`\1`>>/' doc/keycmds.dsv > doc/keycmds-linked.dsv

fmt:
	astyle --suffix=none --style=java --indent=tab --indent-classes *.cpp include/*.h src/*.cpp rss/*.{cpp,h} test/*.cpp

cppcheck:
	cppcheck -j$(CPPCHECK_JOBS) --force --enable=all --suppress=unusedFunction \
		-DDEBUG=1 \
		$(INCLUDES) $(DEFINES) \
		include filter newsboat.cpp podboat.cpp rss src stfl \
		test/*.cpp test/*.h \
		2>cppcheck.log
	@echo "Done! See cppcheck.log for details."

install-newsboat: $(NEWSBOAT) doc/$(NEWSBOAT).1
	$(MKDIR) $(DESTDIR)$(prefix)/bin
	$(INSTALL) $(NEWSBOAT) $(DESTDIR)$(prefix)/bin
	$(MKDIR) $(DESTDIR)$(mandir)/man1
	$(INSTALL) doc/$(NEWSBOAT).1 $(DESTDIR)$(mandir)/man1 || true

install-podboat: $(PODBOAT) doc/$(PODBOAT).1
	$(MKDIR) $(DESTDIR)$(prefix)/bin
	$(INSTALL) $(PODBOAT) $(DESTDIR)$(prefix)/bin
	$(MKDIR) $(DESTDIR)$(mandir)/man1
	$(INSTALL) doc/$(PODBOAT).1 $(DESTDIR)$(mandir)/man1 || true

install-docs: doc
	$(MKDIR) $(DESTDIR)$(docdir)
	$(INSTALL) -m 644 doc/xhtml/* $(DESTDIR)$(docdir) || true

install-examples: doc/example-config
	$(MKDIR) $(DESTDIR)$(docdir)/examples
	$(INSTALL) -m 644 doc/example-config $(DESTDIR)$(docdir)/examples/config || true

install: install-newsboat install-podboat install-docs install-examples install-mo

uninstall: uninstall-mo
	$(RM) $(DESTDIR)$(prefix)/bin/$(NEWSBOAT)
	$(RM) $(DESTDIR)$(prefix)/bin/$(PODBOAT)
	$(RM) $(DESTDIR)$(mandir)/man1/$(NEWSBOAT).1
	$(RM) $(DESTDIR)$(mandir)/man1/$(PODBOAT).1
	$(RM) -rf $(DESTDIR)$(docdir)
	$(RM) -r $(DESTDIR)$(docdir)

.PHONY: doc clean distclean all test test-rss extract install uninstall regenerate-parser clean-newsboat \
	clean-podboat clean-libboat clean-librsspp clean-libfilter clean-doc install-mo msgmerge clean-mo \
	test-clean config cppcheck

# the following targets are i18n/l10n-related:

run-i18nspector: $(POFILES)
	i18nspector $^

mo-files: $(MOFILES)

extract:
	$(RM) $(POTFILE)
	xgettext -c/ -k_ -k_s -o $(POTFILE) *.cpp src/*.cpp rss/*.cpp

msgmerge:
	for f in $(POFILES) ; do msgmerge -U $$f $(POTFILE) ; done

%.mo: %.po
	$(MSGFMT) --check --statistics -o $@ $<

clean-mo:
	$(RM) $(MOFILES) po/*~

install-mo: mo-files
	$(MKDIR) $(DESTDIR)$(datadir)
	@for mof in $(MOFILES) ; do \
		mofile=`basename $$mof` ; \
		lang=`echo $$mofile | sed 's/\.mo$$//'`; \
		dir=$(DESTDIR)$(localedir)/$$lang/LC_MESSAGES; \
		$(MKDIR) $$dir ; \
		$(INSTALL) -m 644 $$mof $$dir/$(PACKAGE).mo ; \
		echo "Installing $$mofile as $$dir/$(PACKAGE).mo" ; \
	done

uninstall-mo:
	@for mof in $(MOFILES) ; do \
		mofile=`basename $$mof` ; \
		lang=`echo $$mofile | sed 's/\.mo$$//'`; \
		dir=$(DESTDIR)$(localedir)/$$lang/LC_MESSAGES; \
		$(RM) -f $$dir/$(PACKAGE).mo ; \
		echo "Uninstalling $$dir/$(PACKAGE).mo" ; \
	done

# tests and coverage reports

test: test/test

TEST_SRCS:=$(shell ls test/*.cpp)
TEST_OBJS:=$(patsubst %.cpp,%.o,$(TEST_SRCS))
test/test: $(LIB_OUTPUT) $(NEWSBOAT_OBJS) $(FILTERLIB_OUTPUT) $(RSSPPLIB_OUTPUT) $(TEST_OBJS) test/test-helpers.h
	$(CXX) $(CXXFLAGS) -o test/test $(TEST_OBJS) src/*.o $(NEWSBOAT_LIBS) $(LDFLAGS)

test-clean:
	$(RM) test/test test/*.o

profclean:
	find . -name '*.gc*' -type f -print0 | xargs -0 $(RM) --
	$(RM) app*.info

# miscellaneous stuff

config: config.mk

config.mk:
	@./config.sh

xlicense.h: LICENSE
	$(TEXTCONV) $< > $@

ALL_SRCS:=$(shell ls filter/*.cpp rss/*.cpp src/*.cpp test/*.cpp)
ALL_HDRS:=$(shell ls filter/*.h rss/*.h test/*.h test/*.hpp) $(STFLHDRS) xlicense.h
depslist: $(ALL_SRCS) $(ALL_HDRS)
	> mk/mk.deps
	for dir in filter rss src test ; do \
		for file in $$dir/*.cpp ; do \
			target=`echo $$file | sed 's/cpp$$/o/'`; \
			$(CXX) $(BARE_CXXFLAGS) -MM -MG -MQ $$target $$file >> mk/mk.deps ; \
			echo $$file ; \
		done; \
	done

include mk/mk.deps

=== debian/changelog ===
newsboat (2.10.2-3) unstable; urgency=medium

  * Drop ncurses-term dependency (not needed as of the last upload)

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Sat, 30 Dec 2017 21:23:45 +0200

newsboat (2.10.2-2) experimental; urgency=medium

  * Bump standards to 4.1.3
    - Update perl hashbang of contrib/pinboard.pl to be compliant
  * Patch spelling errors reported by lintian
  * Bump debhelper compat version to 11 (No changes necessary)
  * Fix package failing to build twice in a row (remove doc/example-config on
    distclean)
  * Manually set TERM variable when running tests to (hopefully) fix the build
    on non-amd64 archs

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Fri, 29 Dec 2017 15:27:26 +0200

newsboat (2.10.2-1) experimental; urgency=medium

  * New upstream release (Closes: #884894, 884892)
  * Fix watch file
  * (Experimentally) Run tests under script (Closes: #884893)

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Wed, 27 Dec 2017 16:30:11 +0200

newsboat (2.10.1-1) unstable; urgency=low

  * Initial release. (Closes: #876327)

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Sun, 22 Oct 2017 12:17:44 +0300

=== debian/control ===
Source: newsboat
Section: net
Priority: optional
Maintainer: Nikos Tsipinakis <nikos@tsipinakis.com>
Build-Depends: libncursesw5-dev, debhelper (>= 11), libxml2-dev, libstfl-dev, libsqlite3-dev, perl, pkg-config, libcurl4-gnutls-dev, libjson-c-dev, asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl, bc
Standards-Version: 4.1.3
Homepage: https://www.newsboat.org

Package: newsboat
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: text mode rss feed reader with podcast support
 newsboat is an RSS/Atom feed reader for the text console. It supports OPML
 import/export, podcasts (via companion program podboat), and can serve as
 a client to various feed aggregators (TT-RSS, The Old Reader, Newsblur,
 FeedHQ, ownCloud/nextCloud News). Its interface draws inspiration from mutt
 and slrn.
 .
 Successor of newsbeuter.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- prefix=/usr all
	make doc

override_dh_auto_install:
	dh_auto_install -- prefix=/usr
	install -m644 debian/config.default $(CURDIR)/debian/newsboat/etc/newsboat/config

override_dh_auto_test:
	dh_auto_test
ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
	cd test && LC_ALL=C.UTF-8 TERM=dumb ./test --order rand
endif

## newsboat 2.11

=== debian/changelog ===
newsboat (2.11-1) unstable; urgency=medium

  * New upstream release (Closes: #888048)
    + Drop 03-clean-example-config.patch: Included upstream
    + Update 02-spelling.patch
    + Update copyright file for catch.hpp and json.hpp

  * Update copyright years

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Tue, 27 Mar 2018 17:28:31 +0300

## newsboat 2.11.1

=== debian/changelog ===
newsboat (2.11.1-1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.
  * Revert to debhelper compat 10 to ease backports.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 10 May 2018 11:50:51 -0700

newsboat (2.11.1-1) unstable; urgency=medium

  * New upstream release
    + Remove 02-spelling.patch: Included upstream

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Sat, 31 Mar 2018 10:21:57 +0300

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,23 @@
 Source: newsboat
 Section: net
 Priority: optional
-Maintainer: Nikos Tsipinakis <nikos@tsipinakis.com>
-Build-Depends: libncursesw5-dev, debhelper (>= 11), libxml2-dev, libstfl-dev, libsqlite3-dev, perl, pkg-config, libcurl4-gnutls-dev, libjson-c-dev, asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl, bc
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Nikos Tsipinakis <nikos@tsipinakis.com>
+Build-Depends: libncursesw5-dev,
+               debhelper (>= 10),
+               libxml2-dev,
+               libstfl-dev,
+               libsqlite3-dev,
+               perl,
+               pkg-config,
+               libcurl4-gnutls-dev,
+               libjson-c-dev,
+               asciidoc,
+               libxml2-utils,
+               xsltproc,
+               docbook-xml,
+               docbook-xsl,
+               bc
 Standards-Version: 4.1.3
 Homepage: https://www.newsboat.org

## newsboat 2.12

=== Makefile ===
--- 
+++ 
@@ -20,8 +20,7 @@
 
 WARNFLAGS=-Werror -Wall -Wextra -Wunreachable-code
 INCLUDES=-Iinclude -Istfl -Ifilter -I. -Irss
-BARE_CXXFLAGS=-std=c++11 -ggdb $(INCLUDES)
-CXXFLAGS+=$(BARE_CXXFLAGS) $(WARNFLAGS) $(DEFINES)
+BARE_CXXFLAGS=-std=c++11 -O2 -ggdb $(INCLUDES)
 LDFLAGS+=-L.
 
 PACKAGE=newsboat
@@ -31,9 +30,11 @@
 endif
 
 ifeq ($(PROFILE),1)
-CXXFLAGS+=-fprofile-arcs -ftest-coverage
+BARE_CXXFLAGS+=-O0 -fprofile-arcs -ftest-coverage
 LDFLAGS+=-fprofile-arcs -ftest-coverage
 endif
+
+CXXFLAGS:=$(BARE_CXXFLAGS) $(WARNFLAGS) $(DEFINES) $(CXXFLAGS)
 
 LIB_SOURCES:=$(shell cat mk/libboat.deps)
 LIB_OBJS:=$(patsubst %.cpp,%.o,$(LIB_SOURCES))
@@ -135,7 +136,7 @@
 	$(RM) doc/*.xml doc/*.1 doc/newsboat-cfgcmds.txt doc/podboat-cfgcmds.txt \
 		doc/newsboat-keycmds.txt doc/configcommands-linked.dsv \
 		doc/podboat-cmds-linked.dsv doc/keycmds-linked.dsv \
-		doc/gen-example-config doc/generate doc/generate2
+		doc/gen-example-config doc/example-config doc/generate doc/generate2
 
 clean: clean-newsboat clean-podboat clean-libboat clean-libfilter clean-doc clean-librsspp
 	$(RM) $(STFLHDRS) xlicense.h
@@ -148,7 +149,7 @@
 doc/xhtml/newsboat.html: doc/newsboat.txt doc/chapter-firststeps.txt doc/configcommands-linked.dsv \
 		doc/keycmds-linked.dsv doc/chapter-tagging.txt doc/chapter-snownews.txt \
 		doc/chapter-cmdline.txt doc/chapter-podcasts.txt doc/podboat-cmds-linked.dsv \
-		doc/chapter-password.txt
+		doc/chapter-password.txt doc/chapter-environment-variables.txt
 	$(MKDIR) doc/xhtml
 	$(A2X) -f xhtml -D doc/xhtml doc/newsboat.txt
 	$(CHMOD) u+w doc/xhtml/docbook-xsl.css
@@ -180,20 +181,21 @@
 
 doc/newsboat.1: doc/manpage-newsboat.txt doc/chapter-firststeps.txt doc/newsboat-cfgcmds.txt \
 		doc/newsboat-keycmds.txt doc/chapter-tagging.txt doc/chapter-snownews.txt \
-		doc/chapter-cmdline.txt
+		doc/chapter-cmdline.txt doc/chapter-environment-variables.txt
 	$(A2X) -f manpage doc/manpage-newsboat.txt
 
 doc/podboat-cfgcmds.txt: doc/generate doc/podboat-cmds.dsv
 	doc/generate doc/podboat-cmds.dsv 'pb-' > doc/podboat-cfgcmds.txt
 
-doc/podboat.1: doc/manpage-podboat.txt doc/chapter-podcasts.txt doc/podboat-cfgcmds.txt
+doc/podboat.1: doc/manpage-podboat.txt doc/chapter-podcasts.txt doc/podboat-cfgcmds.txt \
+		doc/chapter-environment-variables.txt
 	$(A2X) -f manpage doc/manpage-podboat.txt
 
 doc/gen-example-config: doc/gen-example-config.cpp doc/split.h
 	$(CXX) $(CXXFLAGS) -o doc/gen-example-config doc/gen-example-config.cpp
 
 doc/example-config: doc/gen-example-config doc/configcommands.dsv
-	cat doc/configcommands.dsv | doc/gen-example-config > doc/example-config
+	sed 's/+{backslash}"+/`\\"`/g' doc/configcommands.dsv | doc/gen-example-config > doc/example-config
 
 # add hyperlinks for every configuration command
 doc/configcommands-linked.dsv: doc/configcommands.dsv
@@ -207,7 +209,7 @@
 	sed -E 's/^([^|]+)/[[\1]]<<\1,`\1`>>/' doc/keycmds.dsv > doc/keycmds-linked.dsv
 
 fmt:
-	astyle --suffix=none --style=java --indent=tab --indent-classes *.cpp include/*.h src/*.cpp rss/*.{cpp,h} test/*.cpp
+	clang-format --style=file -i *.cpp doc/*.cpp include/*.h rss/*.h rss/*.cpp src/*.cpp test/*.h test/*.cpp
 
 cppcheck:
 	cppcheck -j$(CPPCHECK_JOBS) --force --enable=all --suppress=unusedFunction \
@@ -222,13 +224,13 @@
 	$(MKDIR) $(DESTDIR)$(prefix)/bin
 	$(INSTALL) $(NEWSBOAT) $(DESTDIR)$(prefix)/bin
 	$(MKDIR) $(DESTDIR)$(mandir)/man1
-	$(INSTALL) doc/$(NEWSBOAT).1 $(DESTDIR)$(mandir)/man1 || true
+	$(INSTALL) -m 644 doc/$(NEWSBOAT).1 $(DESTDIR)$(mandir)/man1 || true
 
 install-podboat: $(PODBOAT) doc/$(PODBOAT).1
 	$(MKDIR) $(DESTDIR)$(prefix)/bin
 	$(INSTALL) $(PODBOAT) $(DESTDIR)$(prefix)/bin
 	$(MKDIR) $(DESTDIR)$(mandir)/man1
-	$(INSTALL) doc/$(PODBOAT).1 $(DESTDIR)$(mandir)/man1 || true
+	$(INSTALL) -m 644 doc/$(PODBOAT).1 $(DESTDIR)$(mandir)/man1 || true
 
 install-docs: doc
 	$(MKDIR) $(DESTDIR)$(docdir)
@@ -296,7 +298,7 @@
 
 test: test/test
 
-TEST_SRCS:=$(shell ls test/*.cpp)
+TEST_SRCS:=$(wildcard test/*.cpp)
 TEST_OBJS:=$(patsubst %.cpp,%.o,$(TEST_SRCS))
 test/test: $(LIB_OUTPUT) $(NEWSBOAT_OBJS) $(FILTERLIB_OUTPUT) $(RSSPPLIB_OUTPUT) $(TEST_OBJS) test/test-helpers.h
 	$(CXX) $(CXXFLAGS) -o test/test $(TEST_OBJS) src/*.o $(NEWSBOAT_LIBS) $(LDFLAGS)
@@ -318,8 +320,8 @@
 xlicense.h: LICENSE
 	$(TEXTCONV) $< > $@
 
-ALL_SRCS:=$(shell ls filter/*.cpp rss/*.cpp src/*.cpp test/*.cpp)
-ALL_HDRS:=$(shell ls filter/*.h rss/*.h test/*.h test/*.hpp) $(STFLHDRS) xlicense.h
+ALL_SRCS:=$(wildcard filter/*.cpp rss/*.cpp src/*.cpp test/*.cpp)
+ALL_HDRS:=$(wildcard filter/*.h rss/*.h test/*.h 3rd-party/*.hpp) $(STFLHDRS) xlicense.h
 depslist: $(ALL_SRCS) $(ALL_HDRS)
 	> mk/mk.deps
 	for dir in filter rss src test ; do \

=== debian/changelog ===
newsboat (2.12-1) unstable; urgency=medium

  * New upstream release (Closes: #897818)

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Tue, 26 Jun 2018 17:10:18 +0300

## newsboat 2.13

=== Makefile ===
--- 
+++ 
@@ -83,7 +83,7 @@
 
 all: doc $(NEWSBOAT) $(PODBOAT) mo-files
 
-NB_DEPS=$(LIB_OUTPUT) $(FILTERLIB_OUTPUT) $(NEWSBOAT_OBJS) $(RSSPPLIB_OUTPUT)
+NB_DEPS=xlicense.h $(LIB_OUTPUT) $(FILTERLIB_OUTPUT) $(NEWSBOAT_OBJS) $(RSSPPLIB_OUTPUT)
 
 $(NEWSBOAT): $(NB_DEPS)
 	$(CXX) $(CXXFLAGS) -o $(NEWSBOAT) $(NEWSBOAT_OBJS) $(NEWSBOAT_LIBS) $(LDFLAGS)
@@ -300,7 +300,7 @@
 
 TEST_SRCS:=$(wildcard test/*.cpp)
 TEST_OBJS:=$(patsubst %.cpp,%.o,$(TEST_SRCS))
-test/test: $(LIB_OUTPUT) $(NEWSBOAT_OBJS) $(FILTERLIB_OUTPUT) $(RSSPPLIB_OUTPUT) $(TEST_OBJS) test/test-helpers.h
+test/test: xlicense.h $(LIB_OUTPUT) $(NEWSBOAT_OBJS) $(FILTERLIB_OUTPUT) $(RSSPPLIB_OUTPUT) $(TEST_OBJS) test/test-helpers.h
 	$(CXX) $(CXXFLAGS) -o test/test $(TEST_OBJS) src/*.o $(NEWSBOAT_LIBS) $(LDFLAGS)
 
 test-clean:

=== debian/changelog ===
newsboat (2.13-2) unstable; urgency=medium

  [ Nikos Tsipinakis ]
  * Patch use after free in itemlist (Closes: #898559)
  * Bump standards to 4.4.0 (no changes)
  * d/control: Add Vcs links
  * d/control: Format dependencies vertically
  * Bump debhelper compat to 12
  * Install contrib directory in docs

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Sat, 17 Aug 2019 10:14:13 +0300

newsboat (2.13-1) unstable; urgency=medium

  * New upstream release
  * Bump standards to 4.2.1
  * Drop build dependency on bc (No longer needed)
  * Add recommends on sensible-utils

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Sun, 23 Sep 2018 21:01:29 +0300

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: newsboat
 Section: net
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Nikos Tsipinakis <nikos@tsipinakis.com>
-Build-Depends: libncursesw5-dev,
-               debhelper (>= 10),
+Maintainer: Nikos Tsipinakis <nikos@tsipinakis.com>
+Build-Depends: debhelper-compat (= 12),
+               libncursesw5-dev,
                libxml2-dev,
                libstfl-dev,
                libsqlite3-dev,
@@ -16,13 +15,15 @@
                libxml2-utils,
                xsltproc,
                docbook-xml,
-               docbook-xsl,
-               bc
-Standards-Version: 4.1.3
+               docbook-xsl
+Standards-Version: 4.4.0
 Homepage: https://www.newsboat.org
+Vcs-Git: https://salsa.debian.org/nikos-guest/newsboat.git
+Vcs-Browser: https://salsa.debian.org/nikos-guest/newsboat
 
 Package: newsboat
 Architecture: any
+Recommends: sensible-utils
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: text mode rss feed reader with podcast support
  newsboat is an RSS/Atom feed reader for the text console. It supports OPML

## newsboat 2.18

=== Makefile ===
--- 
+++ 
@@ -9,14 +9,12 @@
 
 # compiler
 CXX?=c++
+# Compiler for building executables meant to be run on the
+# host system during cross compilation
+CXX_FOR_BUILD?=$(CXX)
 
 # compiler and linker flags
 DEFINES=-DLOCALEDIR=\"$(localedir)\"
-
-ifneq ($(wildcard .git/.),)
-GIT_HASH:=$(shell git describe --abbrev=4 --dirty --always --tags)
-DEFINES+=-DGIT_HASH=\"$(GIT_HASH)\"
-endif
 
 WARNFLAGS=-Werror -Wall -Wextra -Wunreachable-code
 INCLUDES=-Iinclude -Istfl -Ifilter -I. -Irss
@@ -25,7 +23,7 @@
 
 PACKAGE=newsboat
 
-ifeq (, $(filter $(MAKECMDGOALS),distclean run-i18nspector))
+ifeq (, $(filter $(MAKECMDGOALS),distclean run-i18nspector fmt))
 include config.mk
 endif
 
@@ -35,6 +33,7 @@
 endif
 
 CXXFLAGS:=$(BARE_CXXFLAGS) $(WARNFLAGS) $(DEFINES) $(CXXFLAGS)
+CXXFLAGS_FOR_BUILD?=$(CXXFLAGS)
 
 LIB_SOURCES:=$(shell cat mk/libboat.deps)
 LIB_OBJS:=$(patsubst %.cpp,%.o,$(LIB_SOURCES))
@@ -47,17 +46,36 @@
 NEWSBOAT=newsboat
 NEWSBOAT_SOURCES:=$(shell cat mk/newsboat.deps)
 NEWSBOAT_OBJS:=$(patsubst %.cpp,%.o,$(NEWSBOAT_SOURCES))
-NEWSBOAT_LIBS=-lboat -lfilter -lpthread -lrsspp
+NEWSBOAT_LIBS=-lboat -lnewsboat -lfilter -lpthread -lrsspp -ldl
 
 RSSPPLIB_SOURCES=$(sort $(wildcard rss/*.cpp))
 RSSPPLIB_OBJS=$(patsubst rss/%.cpp,rss/%.o,$(RSSPPLIB_SOURCES))
 RSSPPLIB_OUTPUT=librsspp.a
 
+CARGO_FLAGS+=--verbose
+ifeq ($(PROFILE),1)
+ifdef CARGO_BUILD_TARGET
+NEWSBOATLIB_OUTPUT=target/$(CARGO_BUILD_TARGET)/debug/libnewsboat.a
+LDFLAGS+=-L./target/$(CARGO_BUILD_TARGET)/debug
+else
+NEWSBOATLIB_OUTPUT=target/debug/libnewsboat.a
+LDFLAGS+=-L./target/debug
+endif
+else
+ifdef CARGO_BUILD_TARGET
+NEWSBOATLIB_OUTPUT=target/$(CARGO_BUILD_TARGET)/release/libnewsboat.a
+LDFLAGS+=-L./target/$(CARGO_BUILD_TARGET)/release
+else
+NEWSBOATLIB_OUTPUT=target/release/libnewsboat.a
+LDFLAGS+=-L./target/release
+endif
+CARGO_FLAGS+=--release
+endif
 
 PODBOAT=podboat
 PODBOAT_SOURCES:=$(shell cat mk/podboat.deps)
 PODBOAT_OBJS:=$(patsubst %.cpp,%.o,$(PODBOAT_SOURCES))
-PODBOAT_LIBS=-lboat -lpthread
+PODBOAT_LIBS=-lboat -lnewsboat -lpthread -ldl
 
 ifeq (, $(filter Linux GNU GNU/%, $(shell uname -s)))
 NEWSBOAT_LIBS+=-liconv -lintl
@@ -72,23 +90,28 @@
 RANLIB?=ranlib
 AR?=ar
 CHMOD=chmod
+CARGO=cargo
 
 STFLHDRS:=$(patsubst %.stfl,%.h,$(wildcard stfl/*.stfl))
 POFILES:=$(wildcard po/*.po)
 MOFILES:=$(patsubst %.po,%.mo,$(POFILES))
 POTFILE=po/newsboat.pot
+RUST_SRCS:=Cargo.toml $(shell find rust -type f)
 
 TEXTCONV=./txt2h
 RM=rm -f
 
 all: doc $(NEWSBOAT) $(PODBOAT) mo-files
 
-NB_DEPS=xlicense.h $(LIB_OUTPUT) $(FILTERLIB_OUTPUT) $(NEWSBOAT_OBJS) $(RSSPPLIB_OUTPUT)
+NB_DEPS=xlicense.h $(LIB_OUTPUT) $(FILTERLIB_OUTPUT) $(NEWSBOAT_OBJS) $(RSSPPLIB_OUTPUT) $(NEWSBOATLIB_OUTPUT)
+
+$(NEWSBOATLIB_OUTPUT): $(RUST_SRCS)
+	$(CARGO) build --package libnewsboat-ffi $(CARGO_FLAGS)
 
 $(NEWSBOAT): $(NB_DEPS)
 	$(CXX) $(CXXFLAGS) -o $(NEWSBOAT) $(NEWSBOAT_OBJS) $(NEWSBOAT_LIBS) $(LDFLAGS)
 
-$(PODBOAT): $(LIB_OUTPUT) $(PODBOAT_OBJS)
+$(PODBOAT): $(LIB_OUTPUT) $(NEWSBOATLIB_OUTPUT) $(PODBOAT_OBJS)
 	$(CXX) $(CXXFLAGS) -o $(PODBOAT) $(PODBOAT_OBJS) $(PODBOAT_LIBS) $(LDFLAGS)
 
 $(LIB_OUTPUT): $(LIB_OBJS)
@@ -130,6 +153,9 @@
 
 clean-libfilter:
 	$(RM) $(FILTERLIB_OUTPUT) $(FILTERLIB_OBJS)
+
+clean-libnewsboat:
+	$(CARGO) clean
 
 clean-doc:
 	$(RM) -r doc/xhtml 
@@ -138,10 +164,10 @@
 		doc/podboat-cmds-linked.dsv doc/keycmds-linked.dsv \
 		doc/gen-example-config doc/example-config doc/generate doc/generate2
 
-clean: clean-newsboat clean-podboat clean-libboat clean-libfilter clean-doc clean-librsspp
+clean: clean-newsboat clean-podboat clean-libboat clean-libfilter clean-doc clean-librsspp clean-libnewsboat
 	$(RM) $(STFLHDRS) xlicense.h
 
-distclean: clean clean-mo test-clean profclean
+distclean: clean clean-mo clean-test profclean
 	$(RM) core *.core core.* config.mk
 
 doc: doc/newsboat.1 doc/podboat.1 doc/xhtml/newsboat.html doc/xhtml/faq.html
@@ -168,13 +194,13 @@
 	echo "td > pre { margin: 0; white-space: pre-wrap; }" >> doc/xhtml/docbook-xsl.css
 
 doc/generate: doc/generate.cpp doc/split.h
-	$(CXX) $(CXXFLAGS) -o doc/generate doc/generate.cpp
+	$(CXX_FOR_BUILD) $(CXXFLAGS_FOR_BUILD) -o doc/generate doc/generate.cpp
 
 doc/newsboat-cfgcmds.txt: doc/generate doc/configcommands.dsv
 	doc/generate doc/configcommands.dsv > doc/newsboat-cfgcmds.txt
 
 doc/generate2: doc/generate2.cpp
-	$(CXX) $(CXXFLAGS) -o doc/generate2 doc/generate2.cpp
+	$(CXX_FOR_BUILD) $(CXXFLAGS_FOR_BUILD) -o doc/generate2 doc/generate2.cpp
 
 doc/newsboat-keycmds.txt: doc/generate2 doc/keycmds.dsv
 	doc/generate2 doc/keycmds.dsv > doc/newsboat-keycmds.txt
@@ -192,7 +218,7 @@
 	$(A2X) -f manpage doc/manpage-podboat.txt
 
 doc/gen-example-config: doc/gen-example-config.cpp doc/split.h
-	$(CXX) $(CXXFLAGS) -o doc/gen-example-config doc/gen-example-config.cpp
+	$(CXX_FOR_BUILD) $(CXXFLAGS_FOR_BUILD) -o doc/gen-example-config doc/gen-example-config.cpp
 
 doc/example-config: doc/gen-example-config doc/configcommands.dsv
 	sed 's/+{backslash}"+/`\\"`/g' doc/configcommands.dsv | doc/gen-example-config > doc/example-config
@@ -209,7 +235,8 @@
 	sed -E 's/^([^|]+)/[[\1]]<<\1,`\1`>>/' doc/keycmds.dsv > doc/keycmds-linked.dsv
 
 fmt:
-	clang-format --style=file -i *.cpp doc/*.cpp include/*.h rss/*.h rss/*.cpp src/*.cpp test/*.h test/*.cpp
+	astyle --project *.cpp doc/*.cpp include/*.h rss/*.h rss/*.cpp src/*.cpp test/*.h test/*.cpp
+	$(CARGO) fmt
 
 cppcheck:
 	cppcheck -j$(CPPCHECK_JOBS) --force --enable=all --suppress=unusedFunction \
@@ -235,10 +262,22 @@
 install-docs: doc
 	$(MKDIR) $(DESTDIR)$(docdir)
 	$(INSTALL) -m 644 doc/xhtml/* $(DESTDIR)$(docdir) || true
+	$(INSTALL) -m 644 CHANGELOG.md $(DESTDIR)$(docdir) || true
+	$(MKDIR) $(DESTDIR)$(docdir)/contrib
+	$(INSTALL) -m 755 contrib/*.sh $(DESTDIR)$(docdir)/contrib || true
+	$(INSTALL) -m 755 contrib/*.rb $(DESTDIR)$(docdir)/contrib || true
+	$(INSTALL) -m 755 contrib/*.pl $(DESTDIR)$(docdir)/contrib || true
+	$(MKDIR) $(DESTDIR)$(docdir)/contrib/colorschemes
+	$(INSTALL) -m 644 contrib/colorschemes/* $(DESTDIR)$(docdir)/contrib/colorschemes || true
+	$(MKDIR) $(DESTDIR)$(docdir)/contrib/getpocket.com
+	$(INSTALL) -m 755 contrib/getpocket.com/*.sh $(DESTDIR)$(docdir)/contrib/getpocket.com || true
+	$(INSTALL) -m 644 contrib/getpocket.com/*.md $(DESTDIR)$(docdir)/contrib/getpocket.com || true
 
 install-examples: doc/example-config
 	$(MKDIR) $(DESTDIR)$(docdir)/examples
 	$(INSTALL) -m 644 doc/example-config $(DESTDIR)$(docdir)/examples/config || true
+	$(INSTALL) -m 755 doc/example-bookmark-plugin.sh $(DESTDIR)$(docdir)/examples/example-bookmark-plugin.sh || true
+
 
 install: install-newsboat install-podboat install-docs install-examples install-mo
 
@@ -252,7 +291,7 @@
 
 .PHONY: doc clean distclean all test test-rss extract install uninstall regenerate-parser clean-newsboat \
 	clean-podboat clean-libboat clean-librsspp clean-libfilter clean-doc install-mo msgmerge clean-mo \
-	test-clean config cppcheck
+	clean-test config cppcheck
 
 # the following targets are i18n/l10n-related:
 
@@ -263,10 +302,15 @@
 
 extract:
 	$(RM) $(POTFILE)
-	xgettext -c/ -k_ -k_s -o $(POTFILE) *.cpp src/*.cpp rss/*.cpp
+	xgettext -c/ -k_ -k_s -o po/cpp.pot *.cpp src/*.cpp rss/*.cpp
+	xtr rust/libnewsboat/src/lib.rs --omit-header -o po/rust.pot
+	cat po/cpp.pot po/rust.pot > $(POTFILE)
+	$(RM) -f po/cpp.pot po/rust.pot
+	sed -i 's#Report-Msgid-Bugs-To: \\n#Report-Msgid-Bugs-To: https://github.com/newsboat/newsboat/issues\\n#' $(POTFILE)
+
 
 msgmerge:
-	for f in $(POFILES) ; do msgmerge -U $$f $(POTFILE) ; done
+	for f in $(POFILES) ; do msgmerge --backup=off -U $$f $(POTFILE) ; done
 
 %.mo: %.po
 	$(MSGFMT) --check --statistics -o $@ $<
@@ -296,14 +340,17 @@
 
 # tests and coverage reports
 
-test: test/test
+test: test/test rust-test
+
+rust-test:
+	$(CARGO) test --no-run
 
 TEST_SRCS:=$(wildcard test/*.cpp)
 TEST_OBJS:=$(patsubst %.cpp,%.o,$(TEST_SRCS))
-test/test: xlicense.h $(LIB_OUTPUT) $(NEWSBOAT_OBJS) $(FILTERLIB_OUTPUT) $(RSSPPLIB_OUTPUT) $(TEST_OBJS) test/test-helpers.h
+test/test: xlicense.h $(LIB_OUTPUT) $(NEWSBOATLIB_OUTPUT) $(NEWSBOAT_OBJS) $(PODBOAT_OBJS) $(FILTERLIB_OUTPUT) $(RSSPPLIB_OUTPUT) $(TEST_OBJS) test/test-helpers.h
 	$(CXX) $(CXXFLAGS) -o test/test $(TEST_OBJS) src/*.o $(NEWSBOAT_LIBS) $(LDFLAGS)
 
-test-clean:
+clean-test:
 	$(RM) test/test test/*.o
 
 profclean:
@@ -318,18 +365,3 @@
 	@./config.sh
 
 xlicense.h: LICENSE
-	$(TEXTCONV) $< > $@
-
-ALL_SRCS:=$(wildcard filter/*.cpp rss/*.cpp src/*.cpp test/*.cpp)
-ALL_HDRS:=$(wildcard filter/*.h rss/*.h test/*.h 3rd-party/*.hpp) $(STFLHDRS) xlicense.h
-depslist: $(ALL_SRCS) $(ALL_HDRS)
-	> mk/mk.deps
-	for dir in filter rss src test ; do \
-		for file in $$dir/*.cpp ; do \
-			target=`echo $$file | sed 's/cpp$$/o/'`; \
-			$(CXX) $(BARE_CXXFLAGS) -MM -MG -MQ $$target $$file >> mk/mk.deps ; \
-			echo $$file ; \
-		done; \
-	done
-
-include mk/mk.deps

=== debian/changelog ===
newsboat (2.18-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 19:16:49 +0100

newsboat (2.18-2) unstable; urgency=medium

  * Bump rust-once-cell build-dep version

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Mon, 30 Dec 2019 15:29:47 +0200

newsboat (2.18-1) unstable; urgency=medium

  [ Nikos Tsipinakis ]
  * New upstream version 2.18
  * Bump policy version to 4.4.1 (No changes needed)
  * Drop fix-ftbfs-without-git.patch (Applied upstream)
  * Refresh relax-deps versions
  * d/control: Update dependency versions for 2.18
  * Relicense debian/ to MIT/Expat
    - With permission from the previous maintainer, Nico Golde.
  * Set cargo home in dh_auto_test

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Thu, 26 Dec 2019 15:48:30 +0200

newsboat (2.16.1-1) unstable; urgency=low

  [ Nikos Tsipinakis ]
  * New upstream version 2.16.1
  * d/control: Add rust dependencies
  * d/rules:
    - Make cargo use /usr/share/cargo as the registry
    - Remove Cargo.lock before build
  * d/patches:
    - Drop 02-fix-use-after-free.patch (fixed upstream)
    - Patch ftbfs when building without git
    - Relax dependency version requirements

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Mon, 28 Oct 2019 12:37:08 +0200

=== debian/control ===
--- 
+++ 
@@ -15,8 +15,34 @@
                libxml2-utils,
                xsltproc,
                docbook-xml,
-               docbook-xsl
-Standards-Version: 4.4.0
+               docbook-xsl,
+               cargo,
+               librust-chrono-0.4-dev,
+               librust-time-0.1-dev,
+               librust-rand-0.7-dev,
+               librust-once-cell-1+parking-lot-dev,
+               librust-regex-1-dev,
+               librust-url-2-dev,
+               librust-dirs-2-dev,
+               librust-xdg-2-dev,
+               librust-backtrace-0.3-dev,
+               librust-backtrace-sys-0.1-dev,
+               librust-unicode-width-0.1-dev,
+               librust-nom-4-dev,
+               librust-unicode-segmentation-1-dev,
+               librust-curl-sys-0.4+ssl-dev,
+               librust-libc-0.2-dev,
+               librust-gettext-rs-0.4-dev,
+               librust-natord-1-dev,
+               librust-clap-2-dev,
+               librust-gettext-sys-0.19-dev,
+               librust-tempfile-3-dev,
+               librust-proptest-0.9+bit-set-dev,
+               librust-proptest-0.9+rusty-fork-dev,
+               librust-proptest-0.9+timeout-dev,
+               librust-percent-encoding-2-dev,
+               librust-section-testing-0.0.4-dev
+Standards-Version: 4.4.1
 Homepage: https://www.newsboat.org
 Vcs-Git: https://salsa.debian.org/nikos-guest/newsboat.git
 Vcs-Browser: https://salsa.debian.org/nikos-guest/newsboat

## newsboat 2.20.1

=== Makefile ===
--- 
+++ 
@@ -75,7 +75,7 @@
 PODBOAT=podboat
 PODBOAT_SOURCES:=$(shell cat mk/podboat.deps)
 PODBOAT_OBJS:=$(patsubst %.cpp,%.o,$(PODBOAT_SOURCES))
-PODBOAT_LIBS=-lboat -lnewsboat -lpthread -ldl
+PODBOAT_LIBS=-lboat -lnewsboat -lfilter -lpthread -ldl
 
 ifeq (, $(filter Linux GNU GNU/%, $(shell uname -s)))
 NEWSBOAT_LIBS+=-liconv -lintl
@@ -85,11 +85,10 @@
 # additional commands
 MKDIR=mkdir -p
 INSTALL=install
-A2X=a2x
+ASCIIDOCTOR=asciidoctor
 MSGFMT=msgfmt
 RANLIB?=ranlib
 AR?=ar
-CHMOD=chmod
 CARGO=cargo
 
 STFLHDRS:=$(patsubst %.stfl,%.h,$(wildcard stfl/*.stfl))
@@ -106,12 +105,12 @@
 NB_DEPS=xlicense.h $(LIB_OUTPUT) $(FILTERLIB_OUTPUT) $(NEWSBOAT_OBJS) $(RSSPPLIB_OUTPUT) $(NEWSBOATLIB_OUTPUT)
 
 $(NEWSBOATLIB_OUTPUT): $(RUST_SRCS)
-	$(CARGO) build --package libnewsboat-ffi $(CARGO_FLAGS)
+	+$(CARGO) build --package libnewsboat-ffi $(CARGO_FLAGS)
 
 $(NEWSBOAT): $(NB_DEPS)
 	$(CXX) $(CXXFLAGS) -o $(NEWSBOAT) $(NEWSBOAT_OBJS) $(NEWSBOAT_LIBS) $(LDFLAGS)
 
-$(PODBOAT): $(LIB_OUTPUT) $(NEWSBOATLIB_OUTPUT) $(PODBOAT_OBJS)
+$(PODBOAT): $(LIB_OUTPUT) $(NEWSBOATLIB_OUTPUT) $(PODBOAT_OBJS) $(FILTERLIB_OUTPUT)
 	$(CXX) $(CXXFLAGS) -o $(PODBOAT) $(PODBOAT_OBJS) $(PODBOAT_LIBS) $(LDFLAGS)
 
 $(LIB_OUTPUT): $(LIB_OBJS)
@@ -159,10 +158,11 @@
 
 clean-doc:
 	$(RM) -r doc/xhtml 
-	$(RM) doc/*.xml doc/*.1 doc/newsboat-cfgcmds.txt doc/podboat-cfgcmds.txt \
-		doc/newsboat-keycmds.txt doc/configcommands-linked.dsv \
-		doc/podboat-cmds-linked.dsv doc/keycmds-linked.dsv \
-		doc/gen-example-config doc/example-config doc/generate doc/generate2
+	$(RM) doc/*.xml doc/*.1 doc/newsboat-cfgcmds.asciidoc \
+		doc/podboat-cfgcmds.asciidoc doc/newsboat-keycmds.asciidoc \
+		doc/configcommands-linked.dsv doc/podboat-cmds-linked.dsv \
+		doc/keycmds-linked.dsv doc/gen-example-config \
+		doc/example-config doc/generate doc/generate2
 
 clean: clean-newsboat clean-podboat clean-libboat clean-libfilter clean-doc clean-librsspp clean-libnewsboat
 	$(RM) $(STFLHDRS) xlicense.h
@@ -170,52 +170,50 @@
 distclean: clean clean-mo clean-test profclean
 	$(RM) core *.core core.* config.mk
 
-doc: doc/newsboat.1 doc/podboat.1 doc/xhtml/newsboat.html doc/xhtml/faq.html
-
-doc/xhtml/newsboat.html: doc/newsboat.txt doc/chapter-firststeps.txt doc/configcommands-linked.dsv \
-		doc/keycmds-linked.dsv doc/chapter-tagging.txt doc/chapter-snownews.txt \
-		doc/chapter-cmdline.txt doc/chapter-podcasts.txt doc/podboat-cmds-linked.dsv \
-		doc/chapter-password.txt doc/chapter-environment-variables.txt
+doc: doc/$(NEWSBOAT).1 doc/$(PODBOAT).1 doc/xhtml/newsboat.html doc/xhtml/faq.html doc/example-config
+
+doc/xhtml/newsboat.html: doc/newsboat.asciidoc doc/chapter-firststeps.asciidoc \
+		doc/configcommands-linked.dsv doc/keycmds-linked.dsv \
+		doc/chapter-tagging.asciidoc doc/chapter-snownews.asciidoc \
+		doc/chapter-cmdline.asciidoc doc/chapter-podcasts.asciidoc \
+		doc/podboat-cmds-linked.dsv doc/chapter-password.asciidoc \
+		doc/chapter-environment-variables.asciidoc \
+		doc/chapter-files.asciidoc
 	$(MKDIR) doc/xhtml
-	$(A2X) -f xhtml -D doc/xhtml doc/newsboat.txt
-	$(CHMOD) u+w doc/xhtml/docbook-xsl.css
-	echo "/* AsciiDoc's new tables have <p> inside <td> which wastes vertical space, so fix it */" >> doc/xhtml/docbook-xsl.css
-	echo "td > p { margin: 0; }" >> doc/xhtml/docbook-xsl.css
-	echo "td > p + p { margin-top: 0.5em; }" >> doc/xhtml/docbook-xsl.css
-	echo "td > pre { margin: 0; white-space: pre-wrap; }" >> doc/xhtml/docbook-xsl.css
-
-doc/xhtml/faq.html: doc/faq.txt
+	$(ASCIIDOCTOR) --backend=html5 -a webfonts! --destination-dir=doc/xhtml doc/newsboat.asciidoc
+
+doc/xhtml/faq.html: doc/faq.asciidoc
 	$(MKDIR) doc/xhtml
-	$(A2X) -f xhtml -D doc/xhtml doc/faq.txt
-	$(CHMOD) u+w doc/xhtml/docbook-xsl.css
-	echo "/* AsciiDoc's new tables have <p> inside <td> which wastes vertical space, so fix it */" >> doc/xhtml/docbook-xsl.css
-	echo "td > p { margin: 0; }" >> doc/xhtml/docbook-xsl.css
-	echo "td > p + p { margin-top: 0.5em; }" >> doc/xhtml/docbook-xsl.css
-	echo "td > pre { margin: 0; white-space: pre-wrap; }" >> doc/xhtml/docbook-xsl.css
+	$(ASCIIDOCTOR) --backend=html5 -a webfonts! --destination-dir=doc/xhtml doc/faq.asciidoc
 
 doc/generate: doc/generate.cpp doc/split.h
 	$(CXX_FOR_BUILD) $(CXXFLAGS_FOR_BUILD) -o doc/generate doc/generate.cpp
 
-doc/newsboat-cfgcmds.txt: doc/generate doc/configcommands.dsv
-	doc/generate doc/configcommands.dsv > doc/newsboat-cfgcmds.txt
+doc/newsboat-cfgcmds.asciidoc: doc/generate doc/configcommands.dsv
+	doc/generate doc/configcommands.dsv > doc/newsboat-cfgcmds.asciidoc
 
 doc/generate2: doc/generate2.cpp
 	$(CXX_FOR_BUILD) $(CXXFLAGS_FOR_BUILD) -o doc/generate2 doc/generate2.cpp
 
-doc/newsboat-keycmds.txt: doc/generate2 doc/keycmds.dsv
-	doc/generate2 doc/keycmds.dsv > doc/newsboat-keycmds.txt
-
-doc/newsboat.1: doc/manpage-newsboat.txt doc/chapter-firststeps.txt doc/newsboat-cfgcmds.txt \
-		doc/newsboat-keycmds.txt doc/chapter-tagging.txt doc/chapter-snownews.txt \
-		doc/chapter-cmdline.txt doc/chapter-environment-variables.txt
-	$(A2X) -f manpage doc/manpage-newsboat.txt
-
-doc/podboat-cfgcmds.txt: doc/generate doc/podboat-cmds.dsv
-	doc/generate doc/podboat-cmds.dsv 'pb-' > doc/podboat-cfgcmds.txt
-
-doc/podboat.1: doc/manpage-podboat.txt doc/chapter-podcasts.txt doc/podboat-cfgcmds.txt \
-		doc/chapter-environment-variables.txt
-	$(A2X) -f manpage doc/manpage-podboat.txt
+doc/newsboat-keycmds.asciidoc: doc/generate2 doc/keycmds.dsv
+	doc/generate2 doc/keycmds.dsv > doc/newsboat-keycmds.asciidoc
+
+doc/$(NEWSBOAT).1: doc/manpage-newsboat.asciidoc doc/chapter-firststeps.asciidoc \
+		doc/newsboat-cfgcmds.asciidoc doc/newsboat-keycmds.asciidoc \
+		doc/chapter-tagging.asciidoc doc/chapter-snownews.asciidoc \
+		doc/chapter-cmdline.asciidoc \
+		doc/chapter-environment-variables.asciidoc \
+		doc/chapter-files.asciidoc
+	$(ASCIIDOCTOR) --backend=manpage doc/manpage-newsboat.asciidoc
+
+doc/podboat-cfgcmds.asciidoc: doc/generate doc/podboat-cmds.dsv
+	doc/generate doc/podboat-cmds.dsv 'pb-' > doc/podboat-cfgcmds.asciidoc
+
+doc/$(PODBOAT).1: doc/manpage-podboat.asciidoc doc/chapter-podcasts.asciidoc \
+		doc/podboat-cfgcmds.asciidoc \
+		doc/chapter-environment-variables.asciidoc \
+		doc/chapter-files.asciidoc
+	$(ASCIIDOCTOR) --backend=manpage doc/manpage-podboat.asciidoc
 
 doc/gen-example-config: doc/gen-example-config.cpp doc/split.h
 	$(CXX_FOR_BUILD) $(CXXFLAGS_FOR_BUILD) -o doc/gen-example-config doc/gen-example-config.cpp
@@ -235,29 +233,26 @@
 	sed -E 's/^([^|]+)/[[\1]]<<\1,`\1`>>/' doc/keycmds.dsv > doc/keycmds-linked.dsv
 
 fmt:
-	astyle --project *.cpp doc/*.cpp include/*.h rss/*.h rss/*.cpp src/*.cpp test/*.h test/*.cpp
+	astyle --project \
+		*.cpp doc/*.cpp include/*.h rss/*.h rss/*.cpp src/*.cpp \
+		test/*.cpp test/test-helpers/*.h test/test-helpers/*.cpp
 	$(CARGO) fmt
 
 cppcheck:
 	cppcheck -j$(CPPCHECK_JOBS) --force --enable=all --suppress=unusedFunction \
 		-DDEBUG=1 \
 		$(INCLUDES) $(DEFINES) \
-		include filter newsboat.cpp podboat.cpp rss src stfl \
-		test/*.cpp test/*.h \
+		include filter newsboat.cpp podboat.cpp rss src stfl test \
 		2>cppcheck.log
 	@echo "Done! See cppcheck.log for details."
 
-install-newsboat: $(NEWSBOAT) doc/$(NEWSBOAT).1
+install-newsboat: $(NEWSBOAT)
 	$(MKDIR) $(DESTDIR)$(prefix)/bin
 	$(INSTALL) $(NEWSBOAT) $(DESTDIR)$(prefix)/bin
-	$(MKDIR) $(DESTDIR)$(mandir)/man1
-	$(INSTALL) -m 644 doc/$(NEWSBOAT).1 $(DESTDIR)$(mandir)/man1 || true
-
-install-podboat: $(PODBOAT) doc/$(PODBOAT).1
+
+install-podboat: $(PODBOAT)
 	$(MKDIR) $(DESTDIR)$(prefix)/bin
 	$(INSTALL) $(PODBOAT) $(DESTDIR)$(prefix)/bin
-	$(MKDIR) $(DESTDIR)$(mandir)/man1
-	$(INSTALL) -m 644 doc/$(PODBOAT).1 $(DESTDIR)$(mandir)/man1 || true
 
 install-docs: doc
 	$(MKDIR) $(DESTDIR)$(docdir)
@@ -272,14 +267,21 @@
 	$(MKDIR) $(DESTDIR)$(docdir)/contrib/getpocket.com
 	$(INSTALL) -m 755 contrib/getpocket.com/*.sh $(DESTDIR)$(docdir)/contrib/getpocket.com || true
 	$(INSTALL) -m 644 contrib/getpocket.com/*.md $(DESTDIR)$(docdir)/contrib/getpocket.com || true
+	$(MKDIR) $(DESTDIR)$(mandir)/man1
+	$(INSTALL) -m 644 doc/$(NEWSBOAT).1 $(DESTDIR)$(mandir)/man1 || true
+	$(INSTALL) -m 644 doc/$(PODBOAT).1 $(DESTDIR)$(mandir)/man1 || true
 
 install-examples: doc/example-config
 	$(MKDIR) $(DESTDIR)$(docdir)/examples
 	$(INSTALL) -m 644 doc/example-config $(DESTDIR)$(docdir)/examples/config || true
-	$(INSTALL) -m 755 doc/example-bookmark-plugin.sh $(DESTDIR)$(docdir)/examples/example-bookmark-plugin.sh || true
-
-
-install: install-newsboat install-podboat install-docs install-examples install-mo
+	$(INSTALL) -m 755 doc/examples/example-bookmark-plugin.sh $(DESTDIR)$(docdir)/examples/example-bookmark-plugin.sh || true
+	$(INSTALL) -m 755 doc/examples/example-exec-script.py $(DESTDIR)$(docdir)/examples/example-exec-script.py || true
+
+install-icon:
+	$(MKDIR) $(DESTDIR)$(datadir)/icons/hicolor/scalable/apps
+	$(INSTALL) -m 644 logo.svg $(DESTDIR)$(datadir)/icons/hicolor/scalable/apps/newsboat.svg
+
+install: install-newsboat install-podboat install-docs install-examples install-mo install-icon
 
 uninstall: uninstall-mo
 	$(RM) $(DESTDIR)$(prefix)/bin/$(NEWSBOAT)
@@ -288,8 +290,9 @@
 	$(RM) $(DESTDIR)$(mandir)/man1/$(PODBOAT).1
 	$(RM) -rf $(DESTDIR)$(docdir)
 	$(RM) -r $(DESTDIR)$(docdir)
-
-.PHONY: doc clean distclean all test test-rss extract install uninstall regenerate-parser clean-newsboat \
+	$(RM) $(DESTDIR)$(datadir)/icons/hicolor/scalable/apps/newsboat.svg
+
+.PHONY: doc clean distclean all test extract install uninstall regenerate-parser clean-newsboat \
 	clean-podboat clean-libboat clean-librsspp clean-libfilter clean-doc install-mo msgmerge clean-mo \
 	clean-test config cppcheck
 
@@ -303,7 +306,7 @@
 extract:
 	$(RM) $(POTFILE)
 	xgettext -c/ -k_ -k_s -o po/cpp.pot *.cpp src/*.cpp rss/*.cpp
-	xtr rust/libnewsboat/src/lib.rs --omit-header -o po/rust.pot
+	xtr rust/libnewsboat/src/lib.rs rust/regex-rs/src/lib.rs --omit-header -o po/rust.pot
 	cat po/cpp.pot po/rust.pot > $(POTFILE)
 	$(RM) -f po/cpp.pot po/rust.pot
 	sed -i 's#Report-Msgid-Bugs-To: \\n#Report-Msgid-Bugs-To: https://github.com/newsboat/newsboat/issues\\n#' $(POTFILE)
@@ -343,25 +346,17 @@
 test: test/test rust-test
 
 rust-test:
-	$(CARGO) test --no-run
-
-TEST_SRCS:=$(wildcard test/*.cpp)
+	+$(CARGO) test --no-run
+
+TEST_SRCS:=$(wildcard test/*.cpp test/test-helpers/*.cpp)
 TEST_OBJS:=$(patsubst %.cpp,%.o,$(TEST_SRCS))
-test/test: xlicense.h $(LIB_OUTPUT) $(NEWSBOATLIB_OUTPUT) $(NEWSBOAT_OBJS) $(PODBOAT_OBJS) $(FILTERLIB_OUTPUT) $(RSSPPLIB_OUTPUT) $(TEST_OBJS) test/test-helpers.h
+test/test: xlicense.h $(LIB_OUTPUT) $(NEWSBOATLIB_OUTPUT) $(NEWSBOAT_OBJS) $(PODBOAT_OBJS) $(FILTERLIB_OUTPUT) $(RSSPPLIB_OUTPUT) $(TEST_OBJS)
 	$(CXX) $(CXXFLAGS) -o test/test $(TEST_OBJS) src/*.o $(NEWSBOAT_LIBS) $(LDFLAGS)
 
 clean-test:
-	$(RM) test/test test/*.o
+	$(RM) test/test test/*.o test/test-helpers/*.o
 
 profclean:
 	find . -name '*.gc*' -type f -print0 | xargs -0 $(RM) --
 	$(RM) app*.info
 
-# miscellaneous stuff
-
-config: config.mk
-
-config.mk:
-	@./config.sh
-
-xlicense.h: LICENSE

=== debian/changelog ===
newsboat (2.20.1-1) unstable; urgency=medium

  * Update vcs url
  * New upstream version 2.20.1
  * Update rust dependencies

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Wed, 29 Jul 2020 14:51:01 +0300

newsboat (2.19-1) unstable; urgency=medium

  * New upstream version 2.19
  * d/control: Remove unicode-segmentation dependency
  * d/control: Replace asciidoc dependency with asciidoctor
  * Refresh patches
  * Bump standards to 4.5.0, no changes

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Tue, 31 Mar 2020 22:45:41 +0200

=== debian/control ===
--- 
+++ 
@@ -11,11 +11,7 @@
                pkg-config,
                libcurl4-gnutls-dev,
                libjson-c-dev,
-               asciidoc,
-               libxml2-utils,
-               xsltproc,
-               docbook-xml,
-               docbook-xsl,
+               asciidoctor,
                cargo,
                librust-chrono-0.4-dev,
                librust-time-0.1-dev,
@@ -28,8 +24,7 @@
                librust-backtrace-0.3-dev,
                librust-backtrace-sys-0.1-dev,
                librust-unicode-width-0.1-dev,
-               librust-nom-4-dev,
-               librust-unicode-segmentation-1-dev,
+               librust-nom-5+lexical-core-dev,
                librust-curl-sys-0.4+ssl-dev,
                librust-libc-0.2-dev,
                librust-gettext-rs-0.4-dev,
@@ -42,10 +37,10 @@
                librust-proptest-0.9+timeout-dev,
                librust-percent-encoding-2-dev,
                librust-section-testing-0.0.4-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://www.newsboat.org
-Vcs-Git: https://salsa.debian.org/nikos-guest/newsboat.git
-Vcs-Browser: https://salsa.debian.org/nikos-guest/newsboat
+Vcs-Git: https://salsa.debian.org/nikos/newsboat.git
+Vcs-Browser: https://salsa.debian.org/nikos/newsboat
 
 Package: newsboat
 Architecture: any
